VirtualDubMod Release Notes
[VirtualDubMod 1.5.4.1]
Belgabor:
- Fixed I18N not working in HexViewer
- Fixed I18N/p18 related bugs in VirtualDub.rc
- OpenGL32.dll and Glu32.dll for the about box are now loaded dynamically.
  This may speed up loading of VirtualDubMod and reduce memeory cost.
  (Well, as long as you don't open the about box ;) )
- Fixed P4 build. LibEBML doesn't work with the Intel compiler, so its compiled 
  with the normal M$ one.
- Added "LoadAviSynth(string path)" to sylia functions.
- Since AviSynth 2.5.2 the special code to allow coloring of external plugin 
  commands is part of the offical codebase. Therfore the special avisynth.dll that
  was available from our page will be removed.
- New icon, designed by mf.
- Updates to the script editor:
    * Added a new mode to the script editor for Decomb override files. So far this is 
      nothing special, except ranges are copied with "," like for the Avisynth 
	  handling (also see next point). Requests are taken for improvements =).
      This mode is auto-set for the extensions ".tel", ".fb" and ".dec".
    * The 'None' mode in the script editor now pastes ranges with "-".
    * Filenames can now be inserted with a nice file open dialog. In 'None' mode they
	  are inserted as-is, in AviSynth mode with "'s around them.
- Fixed a stupid bug with the 'Save & open in Virtualdub' function in the Editor.

Cyrius:
- Fixed a bug that would multiply the number of audio streams coming from the
  opened video file when using the Refresh feature.
- Fixed bug not showing properly the video panes when opening via AviSynth.
- Fixed crash when opening via AviSynth without using a script.
- Fixed bug reseting the frame position to 0 when refreshing.
- Really added the SaveMKV functions for Sylia (better for batch mode :p).
- Fixed ending crash when compressing to MP3 inside VirtualDubMod.
- Fixed bug where disabled streams would still be written in the Job file.
- Quick fix (seems to work) for the program crashing when being called with
  the /x commandline options, and when the input file is in YV12 (i.e.
  generally an avs file).
- Fixed bug generating invalid OpenDML (>2GB) AVI files introduced in 1.5.1.1a
  when using audio streams.
- Fixed a bug (generally a crash) when reading Matroska files in CBR mode
  (e.g. 'Preview' instead of 'Preview VBR')
- Externalized the modified resize filter (the one based on and replacing the
  internal VirtualDub resize filter in 1.4.x versions of VirtualDubMod).
  Fixed some bugs in it as well :)
- Coded an extended TreeView control for the Preferences.
- Added support of 'rec' lists when writing AVI files (similar to AVI-Mux GUI).
  Finalization of AVI files takes some time when using this option.
- Updated libebml/matroska to latest versions (fixed some memory leaks).
- Fixed some memory leaks in Matroska support.
- Fixed bug preventing VDubMod from accepting AC3 files with a bitstream
  version lower than 8 (current specs version is v8).
- Fixed some crashes when reading mkv files (demuxing / transmuxing, ...).
- 'Interleaving' item of the 'Audio' menu is now accessible to subtitle streams
  when right-clicking in the stream list. Allow to change the stream offset.
- Fixed some bugs in the Matroska support.
- Matroska files with unknown audio tracks (unhandled IDs) are now accepted.
  Those tracks will only remain valid when being remuxed in a Matroska file.
- Added an option (Preferences) to speed up Matroska reading in VirtualDubMod.
  This requires more memory but Matroska reading part is 5x faster.
- Fixed another crash in the CBR reading code of Matroska files.
- Lowered a bit memory consumption when parsing OGM/MKV files (<10% gain).
- Moved VirtualDubMod preferences in its own registry binary entry to prevent
  any future conflict with VirtualDub (in case Avery Lee adds preferences).
  Nb : those settings have thus been reseted to default values. Matroska prefs
  were already in a separate registry entry and aren't reseted.
- Added audio clipping settings in the 'Interleaving' window, which allow to
  have different settings for each track. Changing those settings in the
  'Video->Select range' window (which show you the default values when adding
  a new track) will apply it to all streams.
- Fixed bug with matroska support where we would write wrong audio IDs ^^; ...
- Fixed rare bug where MP3 streams in AVI may be read as using Nandub tricks
  while they don't (thus leading to out-of-synch issues when editing).
- Fixed bug with AVI 'rec' lists (last one not being properly closed).
- Merged 1.5.4 changes (and added a bunch of brand new bugs :p)
- When opening a video for which no VfW decompressor could be found the program
  forces 'Direct stream copy' mode and uncheck the 'Show input/output video' menu
  items. A warning will appear to let you know about that.
- Now handle unknown Matroska video stream IDs. In this particular case you are
  only allowed to 'Direct stream copy' to another Matroska file.
- Can now process subtitle streams in Matroska files (only properly handle non
  overlapping subtitle streams).
- Gained some more space in the way Matroska information are stored in memory
  when parsing a file. The new (faster) read method is always used now.
- Fixed bug where keyframes reported when reading a Matroska file would be wrong
  when there are consecutive dropped frames in the stream.
- Fixed bug where keyframes reported when reading an OGM/Matroska file would be
  wrong in the last 7 frames.
- Native MPEG4 streams (with B-frames) coming from Matroska files are supported
  (for editing and recompressing; uses XviD codec).
- (Log) Error appears when you open / append an OGM file containing errors.
- (Log) Error appears when you open an SRT file containing errors.
- Bad subtitles (invalid times, ...) in SRT files are discarded and don't stop
  the file processing anymore.
- Thanks to 'The Crazy Rabbit' for updating codecs.ini with the help of abcAVI.
- Now uses libebml class that should handle >2GB matroska files.
- The 'Mpeg Audio' import filter should better import all kind of streams now
  (MPEG v.1/2/2.5, Layer I/II/III).
- Now handle even overlapping subtitles in Matroska files (may still be buggy).
- Fixed bug where some frames were considered as dropped ones while lacing was
  used on the video track (happen with some files not muxed with VDubMod).
- Support basic (not nested) tags and chapters in Matroska files (see the doc).

[VirtualDubMod 1.5.1.1a]
Belgabor:
- Converted all my stuff to 1.5
- Since Averys error scan works now I ditched my version.
- Assimilated Tdll.h from ffdshow. It provides a class for dll loading.
  Also prepared AviSynth filtering inside VDubMod with a Object
  encapsulation avisynth.dll
- Included fccHandlers MPEG2 mod. AC3 support is enabled
- Pictures showing whether a command is a keyword, internal or external in
  Avisynth syntax completion
- Moved all AviSynth command stuff to CAviSynth
- i18n Completed. Autoloads VDMLang(Three letter code).dll. Custom dll can be set 
  in Display Properties.

Cyrius:
- Rewrote the MP3 & AC3 import parts which are now used in both AVI (previously
  using Nandub code) and OGM menu. The new code has some features to 'handle'
  corrupted data (you can throw or keep those data; if kept the code will treat
  those data as audio frames and try to prevent audio desynchronisation). Nb :
  * when opening an MP3 file that appears to be VBR you will be asked what
    to do (as for AVI)
  * this new code seems to fix some out of synch issues reported concerning the
    use of 'MP3 (CBR) audio'
  * this code also store various information concerning the structure of the
    file but should take far less memory than the one previously used in the
    OGM menu, especially for the AC3 part
- Started merging of AVI 'Audio' & 'Audio2' menu with the 'OGM' one. This should
  allow to have more than 2 audio streams in an AVI, and will make my life easier
  (I hope) in the future :p. All streams 'vital' information are now accessible
  in the new 'Streams' menu. This includes a list of all available streams (except
  main video of course) and accessiblity to specific settings of each stream such
  as interleaving, filters, compression, comments, chapters, ...
  The 'Audio' menu features are accessible for each audio stream in the list by
  right-clicking on the concerned stream (popup menu).
  You can choose which audio stream in the available streams you want to preview.
  Keep in mind that audio specific options (filters, compression, ...) generally
  requires the audio to be decompressed, so before using those features please
  be sure you have such a decompressor, or that the audio is already PCM.
- Removed the 'Audio' menu since its options are now accessible for each audio
  stream in the 'Streams -> Stream list' window. This also means that there is no
  more audio mode (None/AVI/WAV) since you can add / remove / enable / disable
  available streams in this window.
  Also removed 'Save WAV' since it is available in the same window.
- The 'FourCC' field in the AVI 'File information' now show the FourCC (4 letters)
  and the name of the correspondant codec. Added an equivalent for the audio with
  the 'Tag'	field that show the wFormatTag value of the audio (hexadecimal value)
  and the correspondant codec.
  The name of the codec is taken from the Codecs.ini file that contains a list of
  known video / audio codecs (this file comes from TCMP, I thank its developpers
  for their good player, having made this file and letting us use it :)).
- Removed the 'Audio2' fields in the DubStatus window. The 'Audio' fields now show
  the state of the first muxed stream (i.e. not necessarily the first audio stream
  of the opened file in case you moved it to another place). The projected filesize
  take into account all the muxed streams though.
- Comments in AVI are now loaded (in the video comments list) when opening a file.
- Added a bit of Unicode in the 'Streams' menu. This is only available for Windows
  that handle Unicode natively (i.e. it isn't available under Win9x).
  You can open external sources which name is in Unicode (well this is not really
  useful for the moment since you can't do the same when opening the main source).
  All comments and chapters strings should be in Unicode (note that AVI comments
  are translated to the ANSI code page; same happens for OGM that doesn't seem to
  handle Unicode).
- Added some code to try handling ASCII/UTF8/Unicode SRT files automatically (worked
  with an ASCII SRT file and its Unicode equivalent generated by SubResynch).
  Note that currently OGM doesn't seem to handle Unicode subtitles so they are
  converted to the default ANSI code page.
- Added the 'Set keyframe on chapters' feature in the 'Tools' menu.
- Added DTS (14 bits format not supported) as possible source format.
- Added a new tab ('Audio') in the preferences. This let you access :
  * the default preload (in ms) for audio streams
  * whether or not the preload must be disabled when not saving to AVI
  * the mimimum number of audio frames to pack in a block
  * whether or not you want to keep corrupted data (in MP3 / AC3 / DTS files)
- You can't 'Save WAV' / 'Demux' a stream and call another time 'Save WAV' / 'Demux'
  or 'Delete' on any stream anymore. Will prevent some of you to play too much and
  make crash the program this way :p
- AC3 is now decoded thanks to liba52 when using 'Full processing mode' or previewing.
  Multichannel streams are converted to 'Dolby surround compatible stereo'.
- Added another option in the 'Audio' preferences. This let you use Priss (VirtualDub
  internal Mpeg audio decoder) instead of an ACM codec when decoding MP3 streams.
  There may be some bugs (in the way I use it, not in Priss ;)), but it seems this
  decoder works better than ACM for MP3 VBR streams :)
- Added a new 'Streams' tab in the dubbing status window. This tab show you the status
  of all the streams being muxed, on the contrary to the 'Main' tab that only show
  you the status for the video and the first stream (generally audio) being muxed.
- Fixed (I hope) the bug with the About box.
- Now use the Corona library to handle other image formats. BMP and TGA are handled
  by VirtualDub internal routines, and PNG / JPEG / GIF / PCX are decompressed
  on-the-fly to BMP thanks to Corona when opening an image sequence. You can save
  image sequences to BMP, TGA (handled by VirtualDub) or PNG (handled by Corona).
  Note that Corona only support PNG output (no BMP, TGA, JPEG, GIF or PCX).
- Added 2 items in the 'Video' menu to let you take snapshots of the input or output
  video and save the image to a file (BMP, TGA or PNG format).
- Added a 'Report' item in the 'Streams' menu. This show you a short report on all
  current sources opened (main information on the stream, plus some additional).
- Enhanced a bit the Ogg/OGM import filter so that it can still open (and try to
  correct a bit) badly corrupted files (files that would give you an 'Invalid Page'
  error and wouldn't open in previous versions). The program also try to artificially
  (i.e. no real data are inserted, only time indexing is modified) 'compensate' for
  lost data (in order to minimize audio/video out-of-sync).
- Vorbis streams are now decompressed when in Preview mode or when using the
  'Full processing mode'. Only the first 2 channels are rendered for multichannel
  streams though.
- Merged 'Save as AVI', 'Save old format AVI', 'Save segmented AVI' and 'Save as OGM'
  in a unique 'Save As' box (you select the format to which you want to save, the
  last you chose being remembered, and you can decide to save in old format AVI or
  to segmented files when available).
  This new 'Save As' window remind you (and let you change) the current video mode
  (Direct stream copy, ...) and the selected video compressor (when recompressing).
  Thanks to sysKin for the idea and a layout example of this 'Save As' box :)
- Added the possibility to segment the output OGM file (in 'Save As' box).
- Fixed a bug allowing chapters belonging to masked subsets to be kept.
- You can now demux subtitles to an ASCII / UTF-8 / Unicode SRT file (ASCII or
  Unicode being choosed by default depending on the type of the input).
- Added a new 'Main' preference : the default Video mode. You can now choose in
  which mode (Direct stream, Fast/Normal recompress, Full processing) start VDubMod.
- Updated the available Language list (Stream comments) to follow the ISO-639-1/2
  standards. By default languages defined in ISO-639-1 are listed; other languages
  (ISO-639-2) can be accessed thanks to a checkbox. If a known language is selected
  the output format (e.g. OGM) will take into account the standard (English Name /
  3 letters code / 2 letters code if available). (information on ISO-639 can be
  found at http://lcweb.loc.gov/standards/iso639-2/englangn.html)
  You can still use user-defined languages (and overcome the standard) ...
- You can now append OGM segments (either automatically when opening an OGM file
  or manually by using 'Append segment'). Streams are merged as is (no correction
  is made if a stream ends at a different time than the video one).
  Stream comments and chapters should also be appended 'correctly' (i.e. there
  shouldn't be duplicated entries if comments are exactly the same, or chapters
  have the same name and the difference between their time is lower than 2ms).
- The file position shown in the control bar (frame number, ...) doesn't take into
  account external sources now (overhead on those can't be accurately computed).
  So it only shows the position of the current frame in the file.
- The deleted/masked subsets are now reapplied when doing a Refresh.
- You can now specify to which file you want to save frame information when using
  the /log option (e.g. /log"c:\YourPath\YourFile.log"). Also the log file now
  use '\r\n' for ending lines instead of '\n' alone.
- The 'Display' preferences now let you choose to have 'Display input video' and
  'Display output video' checked or not when starting VirtualDubMod.
- Started to add a basic Matroska support. See http://www.matroska.org for more
  information on Matroska.
Nb : as you can imagine all this implied a lot of changes in VirtualDub and
VirtualDubMod sources ... which means there may still be a lot of bugs ...

Stone-D:
- Merged Auto-Resize and added to Display Preferences. The initial resize when
  VirtualDubMod starts follow the preferences choice too.
- Implemented ASF parsing. Same as before, to activate it you must
  uncomment '#define ALLOW_ASF_PARSING' in VirtualDub.h.

[VirtualDubMod 1.4.13.2]
Cyrius:
- Some NET mode related bug fixes.
- Fixed crash when selecting a NULL LANGUAGE comment ('LANGUAGE=(null)')
- Fixed wrong interleaving in per-ms mode on a VBR MP3 stream ala Nandub.
  Thanks to Steven Greenberg (Doom9's forum) for pointing out the problem
  and providing a quick fix.
- When opening a file VDubMod should now show the first frame.
- Fixed bug when demuxing stream from an OGM file :
  * SRT file wouldn't contain the subtitles (first one at most)
  * When demuxing with WAV header and overwriting an existing file
    (longer than the stream being demuxed) some bytes from the old
    file would remain at the end of the demuxed stream
- Disabled initial resizing code as well.
  Put in the same #ifdef test than other resizing code.
- The Job window now appear when launching VDubMod to process queued jobs.
  Should prevent VDubMod from crashing in those cases (e.g. when being used
  by GKnot) because some variables are initialized when opening this window.
- Added jonny's mods (Doom9 forum, DivX 5 Enc author) - commandline options :
  * /log : generates (in the same directory) a vdenc.log file containing
    some information (type and size of frame) about the clip
  * /nowrite : prevent VirtualDubMod from writing video data in the output file
  Nb : those options must be placed before any other because VirtualDub(Mod)
  parse the commandline on sequence.
- Batch process still stop in NET mode when an error occurs for one job.
- MP3 VBR handling a la Nandub is now a preference setting (that can be saved).
  See the 'AVI' section in the 'Preferences' window. Each time a VBR stream is
  found inside an AVI the VBR warning will be shown (like in VirtualDub) and
  you will be asked if default setting must be applied or not for this stream.
- 'AC3 Frame mode' has been put in the preferences too. You will still be able
  to enable/disable this feature when opening an AC3 file (for AVI audio), but
  the checkbox is now set according to the default setting.
- Added the list of functions available for VDubMod scripts in the Help file.
- Added DeXt mods to allow .lst/.m2v opening with the current VOB support.
- Fixed a bug making VirtualDubMod eat a lot of memory instead of writing data
  in the file when saving to OGM with streams that end long before the video.
- Made a fix so that some subtitle engines (the one in latest BSPlayer for
  example) won't eat the last char of the subtitle when displaying it.
  Thanks to Alxemi (Doom9 forum) for mentionning this problem.
- Fixed my (Belgabors) dumb Script Editor Bug
- Fixed a bug causing muxing problems (only video processed, endless muxing) when
  trying to Save to OGM streams you already muxed one time (without exiting the
  program or reloading the audio sources). This bug had been introduced in 1.4.13.2
- Fixed a bug concerning out-of-sync issues using a CBR MP3 audio input

Belgabor:
- Reorganized the menu to make it clearer.
- Merged Streams and Cyrius' NET mod fixes.
- Release Notes more aptly named changelog.
- Disabled resizing code till Stone-D implements preferences.
  (I put it under a #define switch, see virtualdub.h)
- The time bar ticks are now switchable between
  * Off
  * Frame mode (normal)
  * Source Key Frames
  * Key Frames in divx3/xvid stats file (load via Tools/Open Stats File...)
- Stats file savable
- Toggle Keyframes in stats file (default key: Space)
- Frame info from stats file
  (Comment on stats file stuff:
   xvid stuff is ready for work [bug reports & feature requests welcome]
   to do list [=dun request, we already thought about & will work on it]:
   * Divx5 log file support
   * Import from chapters file / ogm chapter info)
- Improved 'Scan video stream for errors'. As the classic vdub version didn't work
  for me in two files i checked, I implemented an improved version which did. Alas
  it's a bit slower so I left the classical version in.
  Both versions do NOT mask frames by default, thus three new menu items have been
  added:
  * Show bad frames
  * Mask bad frames (like what the classic scan did automatically)
  * Delete bad frames (like marking the frames and pressing 'Del')
  To prevent mistakes, the mask and delete commands flush the internal frame list, so
  none of these three commands will work afterwards until you rescan the stream.
- Changed comments display in script editor. Italics looked awful for the new font.
- Updated internal AviSynth keywords for 2.51
- Syntax highlighting for AviSynth plugins. DOES ONLY WORK WITH THE SPECIAL AVISYNTH
  VERSION FROM THE VIRTUALDUBMOD PROJECT PAGE!
- Backported some script editor bug fixes (memory leaks) from 1.5

Stream:
- Fixed several bugs
  * NET mod stop with script error on final stage of encode.
  * NET mod crash when input path-name is too long.
  * Can't load processing setting if external WAV file is set
    as audio source.
  * NET mod stop if output type is old format AVI.
  * NET mod stop if output type is OGM.
  * NET mod freeze when input is too short.
  * NET mod freeze when input file is MPEG-2.
  * NET mod freeze when input file is OGM.
  * CBR MP3 muxing cause audio being out of sync.
  * Script error occurred when OGM comments include special character.
  * Whole batch process stopped after an error in a job.

Errata to the last changelog:
Its wrong that Cyrius didnt like '1337', he just didnt know what it means :p

[VirtualDubMod 1.4.13.1]
S_O & fccHandler (virtualdub.everwicked.com):
- Fixed several Mpeg-1 problems:
  * Audio Layer 1 wasn't played correctly (fccHandler)
    (Layer2.cpp in NekoAmp modified)
  * VBR Audio wasn't parsed correctly (fccHandler)
  * MPEG with multiple Video/Audio-Streams wasn't played correctly (fccHandler)
  * Fixed the bug introduced by multiple stream-fix where mpegs with no
    0xC0/0xE0 audio/video stream cannot be opened (S_O)
  * Stream Selection in the MPEG-Opening-Dialog works (S_O)
  * Accepts Partial MPEGs by default (with warning message) (S_O)
  * The most terrible bug of all fixed (S_O comment ;)) :
    The flying cube-icon in the about-dialog now starts at a random place.

Stone-D:
- Added the ability to import ASF format videos [1]
  This Code is only for educational purposes and not activated
  for binary releases!
- Added code to auto-resize main window when :
  * Opening AVI
  * Toggling Vert/Swap
  * Misc other locations which I've forgotten.  ;)
- Centre main window at startup
- Prevented crash when closing dubmod while dub in progress.

[1] Uncomment "#define ALLOW_ASF_PARSING" in VirtualDub.h

Belgabor:
- Configurable Hotkeys. Main Window, Capture Window & Script Editor. This means the
  old config dialog for the switchable hotkey for refresh / preview is now gone.
- Made P4 compilation work. Added a new configuration for it. (Mind that I made the
  compilation work. I have no P4, so I cant check if the resulting file actually works!)
- AviSynth Information in Script Editor showing AviSynth version
- Help
- Removed OGG/Vorbis for "normal" AVI audio. It won't ever work and its greyed out state
  confused users.
- Added Stone-D's autorsize stuff on Refresh
- New cool (Cyrius didnt like '1337' :p) About Box :p
- Save performance settings. This includes the options set in "Options\Performance...",
  "Options\Dynamic Compilation...", "Options\Drop Frames when behind" and "Options\
  Enable DirectDraw acceleration"

Pulco-Citron:
- AVI information dialog : bye bye "unknown tag 2000" when opening a file with an AC3 stream.
- when opening MPEG2 files, audio streams are auto-detected, sometimes (bye bye "unknown audio
  stream"). Still not works for every file (very short files often cause problems).
  Remember that opening vob files is always easier with a smartripper .txt file...
- Ability to choose output directory for files generated by the MPEG2 import filter.
- Ability to force re-generation of audio and index file for MPEG2.
- CBR MP3 in audio menus. Script support should be working too.
- The host list in the job control window is no longer updated when opening the window:
  the user must click "update". The reason is that on big (really big) LANs the time
  to build the host list is very very long.

Cyrius:
- Fixed a memory leak when saving to PNG files.
- Fixed bug showing wrong progress status when saving / demuxing an audio stream.
- Merged with VirtualDub 1.4.13.
- Added "Title", "Author", "Copyleft" and "Comment" fields when saving to AVI (like
  in Nandub).
- Merged LAN mods from Thomas-Matern (website : http://www.matern-parkett.de/dub/).
  Not really tested (don't have a LAN here ^^).
- Fixed a bug not taking into account external Ogg/AC3/MP3/SRT streams when computing file
  position.
- Fixed a bug causing VBR audio being out of synch when saving a part of a clip (not beginning
  at the first frame of the clip) where subsets have been masked / deleted. (CBR version
  ofarm_disallowed_event this bug have been fixed in 1.4.11.2).
- Made some changes in the internal resize filter GUI (thanks to mf suggestions).
- Fixed a crash when using subsets on an OGM file in some cases.
- Made some changes in the way VirtualDubMod select where to split an AVI file when using
  "Save segmented AVI". It should now cut on a KeyFrame, but only in those specific cases :
  * You are in 'DirectStream copy' mode.
  * You are in another mode, but do not use any preload for the audio.
  The preload feature make it 'impossible' to be able to cut on a KeyFrame when compressing.
- When opening an OGM file, now try to 'detect' if an offset have been used on the streams.
  If an offset seems to be present use it in 'Show inputs' as default offset for the stream.
- The default jobs file name is now based on the .exe name, which means that if you rename
  VirtualDubMod.exe in VirtualDub.exe then the default jobs file will become VirtualDub.jobs
  instead of VirtualDubMod.jobs [2].
- External files selected in 'OGM -> Show inputs' window are not removed anymore when using
  the 'Refresh' feature.
- Fixed some bugs in the 'Go to last keyframe' feature :
  * Now take into account the (selected) streams loaded in the 'OGM -> Show inputs' window.
  * Go on the last keyframe in the clip when the size entered is between this frame and the end
  of the file.
- You can now put the 'Save WAV' & 'Demux audio' in your Job list.
- Fixed a bug adding some (46) 0x00 bytes at the end of a 'Demux audio' file.

[2] Note for GordianKnot users : this is a workaround for current versions of GKnot which uses
only the VirtualDub.jobs file in batch mode. To be able to use GKnot as usual you just need
to rename VirtualDubMod.exe in VirtualDub.exe


[VirtualDubMod 1.4.12.1]
Belgabor:
- Some Script Editor related bug fixes
- Added AviSynth 2.07 Keywords

Cyrius:
- Merged with VirtualDub 1.4.12.
- Special support added for XviD B-frame mode.
- Quick bug-fix for problems (blue tinted clips) when recompressing a DivX video (DivX 5 codec).
- Fixed bug showing a wrong progress status in the Job Control window
- Fixed a bug crashing VirtualDubMod when trying to demux a non-Ogg/AC3/MP3/SRT stream from
  an OGM file.
- OGM streams can now be demuxed (Demux) or saved to a WAV file (Save to WAV) in the
  "OGM inputs" window. The WAV header is not added for Ogg/SRT streams however.


[VirtualDubMod 1.4.11.2]
Belgabor:
- Scintilla component for script editor. Be sure to get SciLexer.dll and AviSynthLexer.lexer
  * Coloring for AVISynth keywords. Red denotes a fuzzy match (likely a type error).
    Coloring for external keywords (plugin filters) is pending till i can get the info via
    AviSynth. Same holds true for the implemenation of parameter hints.
  * Completion with Ctrl+Space or Shift+Space
  * Brace Highlighting. White on red denotes a mismatch.
  * Ctrl+Shift+Alt-C/U Comments/Uncomments selected lines
  * Ctrl-I Imports the Frameset (= the effective video stream created by selecting ranges and
    hitting 'Delete'. I guess you get what I mean ^^) as Trim statements.
- Updated Sync to 1.03

Cyrius:
- Audio :
  * fixed some bug/crash when previewing AVI with 2 audio streams.
  * fixed bug causing all audio data being written in the same audio track (i.e. making
    the secondary audio track and the generated AVI file useless).
  * fixed bug (from Nandub) making impossible to use two audio tracks when deffering processing.
  * "AVI information" window now contains information about the secondary audio stream in AVI.
  * made a little change for the "Preload skew" tab in "AVI Information". Should be more
    accurate than usual ;). In certain cases this value is however not really revelant :
     -> for AC3 streams muxed in "Frame mode" (see below), you should only see 1536 samples
     -> for MP3 streams muxed a la Nandub, you should see something around 1152 samples (or much
        more if your file contains an ID3 tag). The more variable is the bitrate, the more will
        vary the value around 1152.
    In those cases it is the way the data are muxed that make this value irrevelant, but rest
    assured that the real preload is neerer (if not equal) to what the user wanted when muxing ;)
  * selecting "No audio" in Audio tab and "AVI audio" in "Secondary stream" tab let you save
    the secondary audio stream when using "Save WAV".
  * added a "Demux audio" feature that produce same output as "Save WAV" without the WAV header.
  * while dubbing information about secondary audio stream are shown again (like in Nandub). When
    writing an OGM output, the "Audio2 data" field also counts the other streams you are muxing.
  * moved "Audio -> Secondary stream" to its own top-level menu : "Audio2".
  * added a "Nandub VBR MP3 compatibility mode" when opening AVI files (disabled by default).
    This should allow you to work on VBR MP3 streams as in Nandub.
    Once again it is just for your convenience. I suggest you to use CBR streams in AVI files,
    or to use OGM format for VBR audio ...
  * added an "AC3 Frame mode" when opening AC3 files (disabled by default).
    This should force VirtualDub to handle AC3 stream properly when cutting (i.e. not to cut in
    the middle of a frame, but on frame boundaries). Seems to work on my test file.
  I disabled both of these features by default because I cannot guarantee no side effect.
  So : USE WITH CARE !!!
  The fact you used those features or not is saved when using "Job List".
- Some minor GUI changes :
  * made the Change Log / Release Notes window resizable (and a bit bigger by default)
  * OGM Information use the same window than above (so resizable too, and Richedit now)
  * gave VirtualDub icon to Hex Editor, RIFF Chunk Tree, Job List, OGM inputs / comments windows
    and previous ones too :)
  * file position (shown for OGM files) a bit more accurate and also shown for AVI files now
- Added "Go to last keyframe" (Ctrl+Shift+J) (Nandub feature) in Edit menu.
- Fixed an annoying bug (VirtualDub) with seeking to previous keyframe when being at the end of
  the clip and having masked / deleted subsets.
- Fixed a bug (VirtualDub) causing audio being out of synch when saving a part of a clip
  (not beginning at the first frame of the clip) where subsets have been masked / deleted.
- VirtualDubMod jobs are now located in VirtualDubMod.jobs instead of VirtualDub.jobs


[VirtualDubMod 1.4.11.1]
Cyrius:
- Enabled VirtualDubMod.vdi (debug information file) generation in project settings.
  Need MapConv.exe (sources provided by Avery Lee on VirtualDub's web site) and ia32.vdi
  (provided by Avery Lee in VirtualDub 1.4.11 sources) to be in the sources directory when compiling.
  You can use the .exe zipped in MapConv.zip (in the CVS).
- Streams in the input OGM file can now be demuxed. To demux a stream, select it in the "OGM inputs"
  window. Demuxing is made this way (without WAV header, except in last case) :
  * Ogg Vorbis -> Ogg file
  * AC3 stream -> AC3 file
  * MP3 stream -> MP3 file
  * SRT stream -> SRT file (non-DOS format)
  * other audio streams (of other type) should be demuxed with a WAV header as if using "Save WAV"
    (but I can't tell this works because I don't have no-Ogg/AC3/MP3/SRT streams in my test files ;))
  As when using "Save WAV", subsets have an effect on demuxed files (but don't use it as a precise
  cutter, because it is not intended to be one).
- VBR MP3 files not being accepted bug fixed. However the resulting AVI can't be properly re-edited
  with VirtualDubMod (due to VirtualDub VBR correction routines).
  Moreover as a lot of person already do, I recommand you to use only CBR streams within AVI files :)

Pulco-Citron:
- Merged with VirtualDub 1.4.11 (lots of features untested).
- Fixed YV12 handling (sh0dan's code).
- Audio :
  * Disabled Audio/Ogg Vorbis Audio menu item. Until someone fixes the code, if it is possible.
  * Cosmetic fixes in Audio menu (when you select WAV audio for instance, it remains selected).
  * Minor (as far as I know) bug fixes in dual audio handling.

Belgabor:
- Made the AVS Editor a general script editor.
  * Can open any file now. Auto-opens the opened movie if its an avs file.
  * Gave it a nice icon ;)
  * Status shows caret position
  * Some more useful Script editor <-> main window interaction
- Updated the app icon to that from 1.4.11 and changed it a bit to make it distinguishable from the
  unmodified VirtualDub
- Some minor fixes


[VirtualDubMod 1.4.10.1 (was 0.1a)]
Belgabor:
- Added VirtualDubMod release notes & homepage link
- Made the display box for release notes etc. a Richedit
- AVS Editor:
  * Included [Toff]s Tweaking Mod (see help menu item for additional info)


(Initial Combination)
Belgabor:
- Added 'Refresh' menu item which reloads the current file to the same frame
- Hotkey for Refresh configurable (choice between F5 and Ctrl+F5, Preview will take the other)
- 'Open via AVISynth' command. This allows you to open any AVISynth compatible video file by automatically
  generating a suitable script by a selectable template. These templates go into the 'templates' directory
  in your VirtualDub directory. Template syntax is the same as for AVISynthesizer (I included
  readme_AVISynthesizer.txt because as of this writing the AVISynthesizer homepage is not available).
  You can choose the default template shown in the open dialog by starting the template description with
  "Default" (note that the template filename has nothing to do with this).
  For this to work flawlessly you need AVISynth 2.05+ and a correctly set plugin directory.
  (Create a registry key called "PluginDir" in HKEY_LOCAL_MACHINE\Software\Avisynth\)
  A workaround if you don't want to do this is adding the needed LoadPlugin lines into the templates.
- AVS Editor (Hotkey Ctrl+E)
  * 'F2' or 'Ctrl+S' Save the changes.
  * 'F5' in the editor SAVES THE CHANGES (NO BACKUP IS MADE!) and refreshes the image in vdub
  * If you open a faulty avs script, you can still open the editor, correct it and reload with 'F5'.
- Included Sync patch by Andreas Dittrich.

Pulco-Citron:
- MPEG2 Support
- Partial YV12 support
- Two Audio Streams Support
- Support for additional audio sources for avi muxing (lots of bugs)

Cyrius:
- OGM support:
  * You can open an OGM file (information about the opened file can be found in "OGM -> OGM Information")
  * You can save to an OGM file ("File -> Save as OGM")
  * You can add external Ogg/AC3/MP3/SRT files to your final OGM file thanks to the "OGM -> Show inputs" menu.
  * OGM streams can be managed thanks to the "OGM -> Show inputs" menu. This include adding, removing
    , discarding, changing order, and managing comments for each stream.
  You can still use the "Audio" and "Audio -> Secondary stream" menus when saving to OGM, but I recommand you
  to use "OGM -> Show inputs" for Ogg/AC3/MP3 files.
  Comments for the video stream and the two audio streams (using the "Audio" menu) are managed thanks
  to "Video comments", "Audio comments" and "Audio2 comments" in the OGM menu.
  Some help is provided when managing comments :
  - you can pick a type of comment thanks to a list of most used comments
  - when selecting a LANGUAGE comment, you can pick a language in a (non-exhaustive) list
  - you can import chapters generated by SmartRipper or chapterXtractor (thanks to Koepi's OggMux code :))
    Nb : use "OGG" preset format in chapterXtractor. You can also use OGG format in DVDDecrypter.
- PNG support for opening / saving image sequences (16-bit depth not allowed when saving)
- FOURCC code (Compressor one) in the AVI information